=== modified file 'CMakeLists.txt'
--- CMakeLists.txt	2013-06-22 07:20:30 +0000
+++ CMakeLists.txt	2013-08-01 21:24:46 +0000
@@ -13,9 +13,10 @@
 set(UI_DIR "${CMAKE_INSTALL_PREFIX}/share/pantheon-files/ui/")
 set(PACKAGE_VERSION 0.1.1)
 set(VERSION 0.1.1)
-configure_file (${CMAKE_SOURCE_DIR}/config.h.cmake ${CMAKE_BINARY_DIR}/config.h)
+configure_file (${CMAKE_SOURCE_DIR}/Config.vala.cmake ${CMAKE_BINARY_DIR}/Config.vala)
 
 add_definitions("-DGETTEXT_PACKAGE=\"${GETTEXT_PACKAGE}\"")
+add_definitions("-DHAVE_DBUS")
 
 option (LIB_ONLY "Build libcore and libwidgets only" FALSE)
 

=== renamed file 'config.h.cmake' => 'Config.vala.cmake'
--- config.h.cmake	2013-05-19 09:53:35 +0000
+++ Config.vala.cmake	2013-08-01 21:24:46 +0000
@@ -1,13 +1,9 @@
-#ifndef H_CONFIG_H
-#define H_CONFIG_H
-
-#cmakedefine GETTEXT_PACKAGE "@GETTEXT_PACKAGE@"
-#cmakedefine PIXMAP_DIR "@PIXMAP_DIR@"
-#cmakedefine UI_DIR "@UI_DIR@"
-#cmakedefine PACKAGE_VERSION "@PACKAGE_VERSION@"
-#cmakedefine VERSION "@VERSION@"
-#cmakedefine GNOMELOCALEDIR "@GNOMELOCALEDIR@"
-#cmakedefine PLUGIN_DIR "@PLUGIN_DIR@"
-
-#define HAVE_DBUS
-#endif
+namespace Config {
+    public const string GETTEXT_PACKAGE = "@GETTEXT_PACKAGE@";
+    public const string PIXMAP_DIR = "@PIXMAP_DIR@";
+    public const string UI_DIR = "@UI_DIR@";
+    public const string PACKAGE_VERSION = "@PACKAGE_VERSION@";
+    public const string VERSION = "@VERSION@";
+    public const string GNOMELOCALEDIR = "@GNOMELOCALEDIR@";
+    public const string PLUGIN_DIR = "@PLUGIN_DIR@";
+}

=== modified file 'libcore/CMakeLists.txt'
--- libcore/CMakeLists.txt	2013-05-19 09:53:35 +0000
+++ libcore/CMakeLists.txt	2013-08-01 21:24:46 +0000
@@ -14,6 +14,7 @@
 include_directories(${CMAKE_CURRENT_SOURCE_DIR})
 
 vala_precompile(VALA_C ${PKGNAME}
+    ${CMAKE_BINARY_DIR}/Config.vala
     gof-callwhenready.vala
     gof-directory-async.vala
     gof-preferences.vala

=== modified file 'libcore/eel-accessibility.c'
--- libcore/eel-accessibility.c	2011-05-25 10:20:49 +0000
+++ libcore/eel-accessibility.c	2013-08-01 21:24:46 +0000
@@ -22,7 +22,6 @@
 	Anders Carlsson <andersca@gnu.org>
 	Michael Meeks   <michael@ximian.com>
 */
-#include <config.h>
 #include <gtk/gtk.h>
 #include <atk/atkrelationset.h>
 #include "eel-accessibility.h"

=== modified file 'libcore/eel-debug.c'
--- libcore/eel-debug.c	2011-05-07 19:35:56 +0000
+++ libcore/eel-debug.c	2013-08-01 21:24:46 +0000
@@ -22,7 +22,6 @@
    Author: Darin Adler <darin@eazel.com>
 */
 
-#include <config.h>
 #include "eel-debug.h"
 
 #include <glib.h>

=== modified file 'libcore/eel-gdk-extensions.c'
--- libcore/eel-gdk-extensions.c	2011-05-07 19:35:56 +0000
+++ libcore/eel-gdk-extensions.c	2013-08-01 21:24:46 +0000
@@ -22,7 +22,6 @@
  *          Ramiro Estrugo <ramiro@eazel.com>
  */
 
-#include <config.h>
 #include "eel-gdk-extensions.h"
 
 #include "eel-glib-extensions.h"

=== modified file 'libcore/eel-gdk-pixbuf-extensions.c'
--- libcore/eel-gdk-pixbuf-extensions.c	2012-06-06 23:03:49 +0000
+++ libcore/eel-gdk-pixbuf-extensions.c	2013-08-01 21:24:46 +0000
@@ -22,7 +22,6 @@
  *          Andy Hertzfeld <andy@eazel.com>
  */
 
-#include <config.h>
 #include "eel-gdk-pixbuf-extensions.h"
 //#include "eel-glib-extensions.h"
 #include <math.h>

=== modified file 'libcore/eel-i18n.c'
--- libcore/eel-i18n.c	2011-05-07 19:35:56 +0000
+++ libcore/eel-i18n.c	2013-08-01 21:24:46 +0000
@@ -20,7 +20,6 @@
    Authors: Frederic Crozat <fcrozat@mandrakesoft.com>
 */
 
-#include <config.h>
 #include <glib.h>
 #include "eel-i18n.h"
 

=== modified file 'libcore/eel-stock-dialogs.c'
--- libcore/eel-stock-dialogs.c	2011-05-07 19:35:56 +0000
+++ libcore/eel-stock-dialogs.c	2013-08-01 21:24:46 +0000
@@ -20,7 +20,6 @@
  * Authors: Darin Adler <darin@eazel.com>
  */
 
-#include <config.h>
 #include "eel-stock-dialogs.h"
 
 #include <glib/gi18n-lib.h>

=== modified file 'libcore/eel-string.c'
--- libcore/eel-string.c	2011-10-08 05:12:03 +0000
+++ libcore/eel-string.c	2013-08-01 21:24:46 +0000
@@ -22,7 +22,6 @@
  * Authors: Darin Adler <darin@eazel.com>
  */
 
-#include <config.h>
 #include "eel-string.h"
 
 #include <errno.h>

=== modified file 'libcore/eel-ui.c'
--- libcore/eel-ui.c	2011-10-11 07:06:28 +0000
+++ libcore/eel-ui.c	2013-08-01 21:24:46 +0000
@@ -21,7 +21,7 @@
  *  Authors: Alexander Larsson <alexl@redhat.com>
  */
 
-#include <config.h>
+#include "marlincore.h"
 #include "eel-ui.h"
 #include "eel-debug.h"
 
@@ -70,7 +70,7 @@
 
     ui = g_hash_table_lookup (ui_cache, filename);
     if (ui == NULL) {
-        path = g_build_filename (UI_DIR, filename, NULL);
+        path = g_build_filename (CONFIG_UI_DIR, filename, NULL);
         if (path == NULL || !g_file_get_contents (path, &ui, NULL, NULL)) {
             g_warning ("Unable to load ui file %s\n", filename); 
         } 

=== modified file 'libcore/eel-vfs-extensions.c'
--- libcore/eel-vfs-extensions.c	2011-05-07 19:35:56 +0000
+++ libcore/eel-vfs-extensions.c	2013-08-01 21:24:46 +0000
@@ -24,7 +24,6 @@
  *          John Sullivan <sullivan@eazel.com>
  */
 
-#include <config.h>
 #include "eel-vfs-extensions.h"
 #include "eel-glib-extensions.h"
 

=== modified file 'libcore/fm-list-model.c'
--- libcore/fm-list-model.c	2013-02-04 21:40:41 +0000
+++ libcore/fm-list-model.c	2013-08-01 21:24:46 +0000
@@ -24,8 +24,6 @@
  *          Dave Camp <dave@ximian.com>
  */
 
-#include <config.h>
-
 #include <string.h>
 #include <gtk/gtk.h>
 #include <glib.h>

=== modified file 'libcore/marlin-file-changes-queue.c'
--- libcore/marlin-file-changes-queue.c	2012-02-18 19:59:04 +0000
+++ libcore/marlin-file-changes-queue.c	2013-08-01 21:24:46 +0000
@@ -19,8 +19,6 @@
  * Author: Pavel Cisler <pavel@eazel.com>  
  */
 
-
-#include <config.h>
 #include "marlin-file-changes-queue.h"
 #include "marlincore.h"
 

=== modified file 'libcore/marlin-file-conflict-dialog.c'
--- libcore/marlin-file-conflict-dialog.c	2012-02-05 16:29:37 +0000
+++ libcore/marlin-file-conflict-dialog.c	2013-08-01 21:24:46 +0000
@@ -21,7 +21,6 @@
  * Authors: Cosimo Cecchi <cosimoc@gnome.org>
  */
 
-#include <config.h>
 #include "marlin-file-conflict-dialog.h"
 
 #include <string.h>

=== modified file 'libcore/marlin-file-operations.c'
--- libcore/marlin-file-operations.c	2013-06-13 01:51:38 +0000
+++ libcore/marlin-file-operations.c	2013-08-01 21:24:46 +0000
@@ -22,7 +22,6 @@
  *          Pavel Cisler <pavel@eazel.com>
  */
 
-#include <config.h>
 #include <string.h>
 #include <stdio.h>
 #include <stdarg.h>

=== modified file 'libcore/marlin-file-utilities.c'
--- libcore/marlin-file-utilities.c	2012-06-06 23:03:49 +0000
+++ libcore/marlin-file-utilities.c	2013-08-01 21:24:46 +0000
@@ -20,7 +20,6 @@
  * Authors: John Sullivan <sullivan@eazel.com>
  */
 
-#include <config.h>
 #include "marlin-file-utilities.h"
 
 #include "gof-file.h"

=== modified file 'libcore/marlin-progress-info-manager.c'
--- libcore/marlin-progress-info-manager.c	2012-06-07 09:30:43 +0000
+++ libcore/marlin-progress-info-manager.c	2013-08-01 21:24:46 +0000
@@ -19,8 +19,6 @@
  * Author: Cosimo Cecchi <cosimoc@redhat.com>
  */
 
-#include <config.h>
-
 #include "marlin-progress-info-manager.h"
 
 struct _MarlinProgressInfoManagerPriv {

=== modified file 'libcore/marlin-progress-info.c'
--- libcore/marlin-progress-info.c	2011-11-22 07:14:19 +0000
+++ libcore/marlin-progress-info.c	2013-08-01 21:24:46 +0000
@@ -21,7 +21,6 @@
  * Author: Alexander Larsson <alexl@redhat.com>
  */
 
-#include <config.h>
 #include <math.h>
 #include <glib/gi18n.h>
 #include "eel-string.h"

=== modified file 'libcore/marlin-trash-monitor.c'
--- libcore/marlin-trash-monitor.c	2011-09-13 20:26:20 +0000
+++ libcore/marlin-trash-monitor.c	2013-08-01 21:24:46 +0000
@@ -19,7 +19,6 @@
  * Author: Pavel Cisler <pavel@eazel.com>
  */
 
-#include <config.h>
 #include "marlin-trash-monitor.h"
 
 #include "marlin-icons.h"

=== modified file 'libcore/marlincore-C.vapi'
--- libcore/marlincore-C.vapi	2013-06-01 18:27:00 +0000
+++ libcore/marlincore-C.vapi	2013-08-01 21:24:46 +0000
@@ -1,13 +1,6 @@
 using Gtk;
 using GLib;
 
-[CCode (cprefix = "", lower_case_cprefix = "", cheader_filename = "config.h")]
-namespace Config {
-    public const string PIXMAP_DIR;
-    public const string UI_DIR;
-    public const string VERSION;
-}
-
 [CCode (cprefix = "FM", lower_case_cprefix = "fm_", cheader_filename = "fm-list-model.h")]
 namespace FM
 {
@@ -54,11 +47,14 @@
 [CCode (cprefix = "Marlin", lower_case_cprefix = "marlin_")]
 namespace Marlin
 {
+    [CCode (cheader_filename = "marlin-file-utilities.h")]
+    string get_accel_map_file ();
     [CCode (cheader_filename = "marlin-icon-info.h")]
     public class IconInfo : GLib.Object {
         public static IconInfo lookup(GLib.Icon icon, int size);
         public Gdk.Pixbuf get_pixbuf_nodefault();
         public Gdk.Pixbuf get_pixbuf_at_size(int size);
+        public static void clear_caches ();
     }
 
     [CCode (cheader_filename = "marlin-abstract-sidebar.h")]

=== modified file 'src/CMakeLists.txt'
--- src/CMakeLists.txt	2013-08-01 13:47:03 +0000
+++ src/CMakeLists.txt	2013-08-01 21:24:46 +0000
@@ -64,6 +64,7 @@
     gconf-2.0
     gee-1.0
     granite
+    libnotify
     marlincore
     marlincore-C
 GENERATE_HEADER

=== modified file 'src/View/DbusTags.vala'
--- src/View/DbusTags.vala	2012-11-06 19:52:04 +0000
+++ src/View/DbusTags.vala	2013-08-01 21:24:46 +0000
@@ -19,6 +19,8 @@
 
 /* TODO merge with ctags plugin */
 
+public Marlin.View.Tags tags;
+
 [DBus (name = "org.elementary.marlin.db")]
 interface CTags : Object {
     public abstract async bool record_uris (Variant[] entries, string directory) 	throws IOError;

=== modified file 'src/eel-editable-label.c'
--- src/eel-editable-label.c	2012-06-12 07:41:29 +0000
+++ src/eel-editable-label.c	2013-08-01 21:24:46 +0000
@@ -23,7 +23,6 @@
  * GTK+ at ftp://ftp.gtk.org/pub/gtk/. 
  */
 
-#include <config.h>
 #include <math.h>
 #include <string.h>
 

=== modified file 'src/exo-icon-view.c'
--- src/exo-icon-view.c	2013-06-01 20:18:10 +0000
+++ src/exo-icon-view.c	2013-08-01 21:24:46 +0000
@@ -23,8 +23,6 @@
  * Boston, MA 02111-1307, USA.
  */
 
-#include "config.h"
-
 #include <stdlib.h>
 #include <string.h>
 

=== modified file 'src/fm-abstract-icon-view.c'
--- src/fm-abstract-icon-view.c	2013-06-30 22:32:32 +0000
+++ src/fm-abstract-icon-view.c	2013-08-01 21:24:46 +0000
@@ -28,7 +28,7 @@
 #include "eel-gtk-extensions.h"
 #include "eel-editable-label.h"
 #include "eel-ui.h"
-#include "marlin-tags.h"
+#include "marlin-vala.h"
 
 enum
 {

=== modified file 'src/fm-columns-view.c'
--- src/fm-columns-view.c	2013-06-29 19:28:16 +0000
+++ src/fm-columns-view.c	2013-08-01 21:24:46 +0000
@@ -26,7 +26,7 @@
 //#include "marlin-cell-renderer-text-ellipsized.h"
 #include "marlin-global-preferences.h"
 #include "eel-gtk-extensions.h"
-#include "marlin-tags.h"
+#include "marlin-vala.h"
 
 /*enum
 {

=== modified file 'src/fm-directory-view.c'
--- src/fm-directory-view.c	2013-06-30 09:33:01 +0000
+++ src/fm-directory-view.c	2013-08-01 21:24:46 +0000
@@ -25,7 +25,6 @@
  *          David Emory Watson <dwatson@cs.ucr.edu>
  */
 
-#include <config.h>
 #include "fm-directory-view.h"
 #include <math.h>
 
@@ -48,7 +47,6 @@
 #include "marlin-icon-renderer.h"
 #include "marlin-text-renderer.h"
 #include "marlin-thumbnailer.h"
-#include "marlin-tags.h"
 #include "marlin-mime-actions.h"
 
 

=== modified file 'src/fm-list-view.c'
--- src/fm-list-view.c	2013-06-30 22:32:32 +0000
+++ src/fm-list-view.c	2013-08-01 21:24:46 +0000
@@ -30,7 +30,7 @@
 #include "marlin-cell-renderer-text-ellipsized.h"
 #include "eel-glib-extensions.h"
 #include "eel-gtk-extensions.h"
-#include "marlin-tags.h"
+#include "marlin-vala.h"
 
 /*enum
 {

=== modified file 'src/main.vala'
--- src/main.vala	2013-07-31 18:35:15 +0000
+++ src/main.vala	2013-08-01 21:24:46 +0000
@@ -14,15 +14,14 @@
   with this program. If not, see <http://www.gnu.org/licenses/>.
 ***/
 
-const string APP_NAME = "pantheon-files";
-const string GETTEXT_PACKAGE = "pantheon-files";
+public static const string APP_NAME = "pantheon-files";
 
 public static int main (string[] args) {
     Gtk.init (ref args);
 
     /* Initiliaze gettext support */
     Intl.setlocale (LocaleCategory.ALL, Intl.get_language_names ()[0]);
-    Intl.textdomain (GETTEXT_PACKAGE);
+    Intl.textdomain (Config.GETTEXT_PACKAGE);
 
     Environment.set_application_name (APP_NAME);
     Environment.set_prgname (APP_NAME);

=== modified file 'src/marlin-application.vala'
--- src/marlin-application.vala	2013-08-01 13:47:03 +0000
+++ src/marlin-application.vala	2013-08-01 21:24:46 +0000
@@ -1,4 +1,4 @@
-Marlin.Application singleton = null;
+private Marlin.Application singleton = null;
 
 public class Marlin.Application : Granite.Application {
     
@@ -13,19 +13,248 @@
     private bool save_of_accel_map_requested = false;
     
     public Application () {
+        base ();
+        singleton = this;
+        this.program_name = "Files";
     }
     
     public static new Application get () {
-        return new Application ();
+        if (singleton == null)
+            singleton = new Marlin.Application ();
+            
+        return singleton;
     }
     
     public void create_window (File location, Gdk.Screen screen) {
+        this.open_window (location, screen);
     }
     
     public new void quit () {
+        foreach (var window in this.get_windows ())
+            window.destroy ();
     }
     
     public bool is_first_window (Gtk.Window window) {
         return false;
     }
+    
+    public override int command_line (ApplicationCommandLine command_line) {
+        bool version = false;
+        bool kill_shell = false;
+        string[] remaining = null;
+        
+        OptionEntry[] options = {};
+        options [0] = { "version", '\0', 0, OptionArg.NONE, ref version,
+                        N_("Show the version of the program."), null };
+        options [1] = { "tab", 't', 0, OptionArg.NONE, ref this.open_intab,
+                        N_("Open uri(s) in new tab"), null };
+        options [2] = { "quit", 'q', 0, OptionArg.NONE, ref kill_shell,
+                        N_("Quit Files."), null };
+        options [3] = { "debug", 'd', 0, OptionArg.NONE, ref this.debug,
+                        N_("Enable debug logging"), null };
+        // "" = G_OPTION_REMAINING
+        options [4] = { "", 0, 0, OptionArg.STRING_ARRAY, ref remaining,
+                        null, N_("[URI...]") };
+        
+        var context = new OptionContext (_("\n\nBrowse the file system with the file manager"));
+        context.add_main_entries (options, null);
+        context.add_group (Gtk.get_option_group (true));
+        
+        string[] args = command_line.get_arguments ();
+        // We need to store args in an unowned variable for context.parse .
+        unowned string[] args_aux = args;
+        
+        try {
+            context.parse (ref args_aux);
+        } catch (OptionError error) {
+            printerr ("Could not parse arguments: %s\n", error.message);
+            return Posix.EXIT_FAILURE;
+        }
+        
+        if (version) {
+            command_line.print ("Files " + Config.VERSION + "\n");
+            return Posix.EXIT_SUCCESS;
+        }
+        
+        if (kill_shell) {
+            if (remaining != null) {
+                command_line.printerr ("%s\n",
+                                       _("--quit cannot be used with URIs."));
+                return Posix.EXIT_FAILURE;
+            } else {
+                this.quit ();
+                return Posix.EXIT_SUCCESS;
+            }
+        }
+
+        File[] files = {};
+        
+        if (remaining != null) {
+            foreach (string filepath in remaining) {
+                var file = File.new_for_commandline_arg (filepath);
+                if (file != null)
+                    files += (file);
+            }
+        }
+        
+        this.open_location (files);
+        
+        return Posix.EXIT_SUCCESS;
+    }
+    
+    public override void startup () {
+        Granite.Services.Logger.initialize ("pantheon-files");
+        Granite.Services.Logger.DisplayLevel = Granite.Services.LogLevel.INFO;
+        
+        message ("Welcome to Pantheon Files");
+        message ("Version: %s", Config.VERSION);
+        message ("Report any issues/bugs you might find to http://bugs.launchpad.net/pantheon-files");
+        
+        if (this.debug)
+            Granite.Services.Logger.DisplayLevel = Granite.Services.LogLevel.DEBUG;
+            
+        init_schemas ();
+        init_gtk_accels ();
+        
+        Gtk.IconTheme.get_default ().notify["changed"].connect (() => {
+            Marlin.IconInfo.clear_caches ();
+        });
+        
+        Notify.init (Config.GETTEXT_PACKAGE);
+        this.progress_handler = new Marlin.Progress.UIHandler ();
+        this.clipboard = new Marlin.Clipboard.Manager.get_for_display (Gdk.Display.get_default ());
+        this.thumbnailer = Marlin.Thumbnailer.get ();
+        
+        tags = new Marlin.View.Tags ();
+    }
+    
+    private void mount_removed_callback (VolumeMonitor monitor, Mount mount) {
+        /* Check and see if any of the open windows are displaying contents from the unmounted mount */
+        unowned List<Gtk.Window> window_list = this.get_windows ();
+        File root = mount.get_root ();
+        
+        /* We browse each slot from each windows, loading home for current tabs and closing the rest */
+        foreach (Gtk.Window window in window_list) {
+            var marlin_window = window as Marlin.View.Window;
+            List<Gtk.Widget> pages = marlin_window.tabs.get_children ();
+            
+            foreach (var page in pages) {
+                var view_container = page as Marlin.View.ViewContainer;
+                var slot = view_container.slot;
+                var location = slot.location;
+                if (location == null || location.has_prefix (root) ||
+                        location.equal (root)) {
+                    if (view_container == marlin_window.current_tab)
+                        Signal.emit_by_name (view_container, "path-changed",
+                                             File.new_for_path (Environment.get_home_dir ()));
+                    else
+                        marlin_window.remove_tab (view_container);
+                }
+            }
+        }
+    }
+    
+    private void init_schemas () {
+        /* GSettings parameters */
+        Preferences.settings = new Settings ("org.pantheon.files.preferences");
+        Preferences.marlin_icon_view_settings = new Settings ("org.pantheon.files.icon-view");
+        Preferences.marlin_list_view_settings = new Settings ("org.pantheon.files.list-view");
+        Preferences.marlin_column_view_settings = new Settings ("org.pantheon.files.column-view");
+        
+        /* Bind settings with GOFPreferences */
+        Preferences.settings.bind ("show-hiddenfiles",
+                                   GOF.Preferences.get_default (), "show-hidden-files", 0);
+        Preferences.settings.bind ("confirm-trash",
+                                   GOF.Preferences.get_default (), "confirm-trash", 0);
+        Preferences.settings.bind ("date-format",
+                                   GOF.Preferences.get_default (), "date-format", 0);
+        Preferences.settings.bind ("interpret-desktop-files",
+                                   GOF.Preferences.get_default (), "interpret-desktop-files", 0);
+    }
+    
+    private void init_gtk_accels () {
+        /* Load accelerator map, and register save callback */
+        string accel_map_filename = Marlin.get_accel_map_file ();
+        if (accel_map_filename != null) {
+            Gtk.AccelMap.load (accel_map_filename);
+        }
+        
+        Gtk.AccelMap.get ().notify["changed"].connect (() => {
+            if (!save_of_accel_map_requested) {
+                save_of_accel_map_requested = true;
+                Timeout.add_seconds (MARLIN_ACCEL_MAP_SAVE_DELAY,
+                                     save_accel_map);
+            }
+        });
+    }
+    
+    private bool save_accel_map () {
+        if (save_of_accel_map_requested) {
+            string accel_map_filename = Marlin.get_accel_map_file ();
+            if (accel_map_filename != null)
+                Gtk.AccelMap.save (accel_map_filename);
+            save_of_accel_map_requested = false;
+        }
+        
+        return true;
+    }
+    
+    
+    private void open_window (File location, Gdk.Screen screen) {
+        var window = new Marlin.View.Window (this, screen);
+        plugins.interface_loaded (window as Gtk.Widget);
+        this.add_window (window as Gtk.Window);
+        window.set_size_request (300, 250);
+        window.add_tab (location);
+    }
+    
+    private void open_windows (File[]? files, Gdk.Screen screen) {
+        if (files == null) {
+            /* Open a window pointing at the default location. */
+            var location = File.new_for_path (Environment.get_home_dir ());
+            open_window (location, screen);
+        } else {
+            /* Open windows at each requested location. */
+            foreach (var file in files)
+                open_window (file, screen);
+        }
+    }
+    
+    private void open_tabs (File[]? files, Gdk.Screen screen) {
+        Marlin.View.Window window;
+        
+        unowned List<Gtk.Window> windows = this.get_windows ();
+        
+        if (windows != null && windows.data != null)
+            window = windows.data as Marlin.View.Window;
+        else {
+            window = new Marlin.View.Window (this, screen);
+            this.add_window (window as Gtk.Window);
+            plugins.interface_loaded (window as Gtk.Widget);
+        }
+        
+        if (files == null) {
+            var location = File.new_for_path (Environment.get_home_dir ());
+            window.add_tab (location);
+        } else {
+            foreach (var file in files)
+                window.add_tab (file);
+        }
+    }
+    
+    private void open_location (File[] files) {
+        //TODO:
+        /*if (this.debug)
+            Granite.Services.Logger.DisplayLevel (Granite.Services.LogLevel.DEBUG);*/
+        
+        /* Create windows */
+        if (this.open_intab)
+            this.open_tabs (files, Gdk.Screen.get_default ());
+        else
+            this.open_windows (files, Gdk.Screen.get_default ());
+        
+        this.open_intab = false;
+    }
+    
+
 }

=== modified file 'src/marlin-bookmark-list.c'
--- src/marlin-bookmark-list.c	2011-11-01 12:09:26 +0000
+++ src/marlin-bookmark-list.c	2013-08-01 21:24:46 +0000
@@ -24,7 +24,6 @@
 /* nautilus-bookmark-list.c - implementation of centralized list of bookmarks.
 */
 
-#include <config.h>
 #include "marlin-bookmark-list.h"
 
 #include <gio/gio.h>

=== modified file 'src/marlin-bookmark.c'
--- src/marlin-bookmark.c	2012-01-02 22:58:23 +0000
+++ src/marlin-bookmark.c	2013-08-01 21:24:46 +0000
@@ -21,7 +21,6 @@
  * Authors: John Sullivan <sullivan@eazel.com>
  */
 
-#include <config.h>
 #include "marlin-bookmark.h"
 #include "marlin-icons.h"
 

=== modified file 'src/marlin-connect-server-dialog.c'
--- src/marlin-connect-server-dialog.c	2013-05-27 10:54:46 +0000
+++ src/marlin-connect-server-dialog.c	2013-08-01 21:24:46 +0000
@@ -20,8 +20,6 @@
  * Boston, MA 02111-1307, USA.
  */
 
-#include <config.h>
-
 #include "marlin-connect-server-dialog.h"
 
 #include <string.h>

=== modified file 'src/marlin-connect-server-operation.c'
--- src/marlin-connect-server-operation.c	2011-07-16 11:07:10 +0000
+++ src/marlin-connect-server-operation.c	2013-08-01 21:24:46 +0000
@@ -21,8 +21,6 @@
  * Author: Cosimo Cecchi <cosimoc@gnome.org>
  */
 
-#include <config.h>
-
 #include "marlin-connect-server-operation.h"
 
 G_DEFINE_TYPE (MarlinConnectServerOperation,

=== modified file 'src/marlin-dnd.c'
--- src/marlin-dnd.c	2012-06-06 23:03:49 +0000
+++ src/marlin-dnd.c	2013-08-01 21:24:46 +0000
@@ -19,7 +19,6 @@
  * Boston, MA 02111-1307, USA.
  */
 
-#include <config.h>
 #include "marlin-dnd.h"
 
 #include <glib/gi18n.h>

=== modified file 'src/marlin-enum-types.c'
--- src/marlin-enum-types.c	2012-11-06 17:21:39 +0000
+++ src/marlin-enum-types.c	2013-08-01 21:24:46 +0000
@@ -17,8 +17,6 @@
  * Place, Suite 330, Boston, MA  02111-1307  USA
  */
 
-#include <config.h>
-
 #include "marlin-enum-types.h"
 
 #define I_(string) (g_intern_static_string ((string)))

=== modified file 'src/marlin-mime-actions.c'
--- src/marlin-mime-actions.c	2012-01-02 23:25:45 +0000
+++ src/marlin-mime-actions.c	2013-08-01 21:24:46 +0000
@@ -22,8 +22,6 @@
  *          ammonkey <am.monkeyd@gmail.com>
  */
 
-#include <config.h>
-
 #include "marlin-mime-actions.h"
 
 static gboolean

=== modified file 'src/marlin-places-sidebar.c'
--- src/marlin-places-sidebar.c	2013-06-27 01:51:03 +0000
+++ src/marlin-places-sidebar.c	2013-08-01 21:24:46 +0000
@@ -21,8 +21,6 @@
  *
  */
 
-#include <config.h>
-
 #include "eel-fcts.h"
 #include "eel-gtk-extensions.h"
 #include "eel-gio-extensions.h"

=== modified file 'src/marlin-progress-info-widget.c'
--- src/marlin-progress-info-widget.c	2012-02-05 16:29:37 +0000
+++ src/marlin-progress-info-widget.c	2013-08-01 21:24:46 +0000
@@ -23,8 +23,6 @@
  *
  */
 
-#include <config.h>
-
 #include "marlin-progress-info-widget.h"
 
 struct _MarlinProgressInfoWidgetPriv {

=== modified file 'src/marlin-progress-ui-handler.c'
--- src/marlin-progress-ui-handler.c	2013-08-01 13:47:03 +0000
+++ src/marlin-progress-ui-handler.c	2013-08-01 21:24:46 +0000
@@ -24,8 +24,6 @@
  *
  */
 
-#include <config.h>
-
 #include "marlin-progress-ui-handler.h"
 
 #include "marlin-vala.h"

=== removed file 'src/marlin-tags.h'
--- src/marlin-tags.h	2010-12-14 17:58:37 +0000
+++ src/marlin-tags.h	1970-01-01 00:00:00 +0000
@@ -1,3 +0,0 @@
-#include "marlin-vala.h"
-
-MarlinViewTags *tags;

=== modified file 'src/marlin-thumbnailer.c'
--- src/marlin-thumbnailer.c	2013-05-18 08:57:15 +0000
+++ src/marlin-thumbnailer.c	2013-08-01 21:24:46 +0000
@@ -17,8 +17,6 @@
  * Boston, MA 02110-1301, USA.
  */
 
-#include <config.h>
-
 #ifdef HAVE_DBUS
 #include <dbus/dbus.h>
 #include <dbus/dbus-glib.h>

=== modified file 'src/marlin.vapi'
--- src/marlin.vapi	2013-08-01 13:47:03 +0000
+++ src/marlin.vapi	2013-08-01 21:24:46 +0000
@@ -6,6 +6,9 @@
 [CCode (cprefix = "", lower_case_cprefix = "", cheader_filename = "marlin-global-preferences.h")]
 namespace Preferences {
     public GLib.Settings settings;
+    public GLib.Settings marlin_icon_view_settings;
+    public GLib.Settings marlin_list_view_settings;
+    public GLib.Settings marlin_column_view_settings;
 }
 
 namespace FM {

=== modified file 'src/unity-quicklist-handler.c'
--- src/unity-quicklist-handler.c	2013-08-01 13:47:03 +0000
+++ src/unity-quicklist-handler.c	2013-08-01 21:24:46 +0000
@@ -23,8 +23,6 @@
  */
 
 #ifdef HAVE_UNITY
-#include <config.h>
-
 #include "unity-quicklist-handler.h"
 
 #include <libdbusmenu-glib/dbusmenu-glib.h>

